/********************************************************************************************************
 * - PAN ID: 0x2176 for example										 								*
 * - Short address: 0x0000 ~ 0xFFFF changeable															*
 ********************************************************************************************************/

#include "include\include.h"

//-------------------------------------------------------------------------------------------------------
// Basic RF transmission and reception structures
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO rfRxInfo;
BASIC_RF_TX_INFO rfTxInfo;
BYTE pTxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];
BYTE pRxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];

//-------------------------------------------------------------------------------------------------------
// (7) ڰ ʿ信   ܺκ
//-------------------------------------------------------------------------------------------------------
//
//  ܺκ ߰
//

//-------------------------------------------------------------------------------------------------------
// (8) ڰ ʿ信   Լ ⿡ ϰų  .c Ͽ Ѵ.
//-------------------------------------------------------------------------------------------------------
//
//  Լ ߰
//

//-------------------------------------------------------------------------------------------------------
//	̺갡  Ÿ  ó Լ
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO* basicRfReceivePacket(BASIC_RF_RX_INFO *pRRI) 
{
//-------------------------------------------------------------------------------------------------------
// (9) pRRI->pPayload[] : ̺κ  Ÿ ó
//-------------------------------------------------------------------------------------------------------
	unsigned char rfrxdata;

	if(pRRI->srcAddr == 0x0002) //  (̺) ּҰ  0x0002̸..
	{
		rfrxdata = pRRI->pPayload[0]; //  Ÿ ó
	// rfrxdata = pRRI->pPayload[1];
	// rfrxdata = pRRI->pPayload[2];
	//...
	//...
	//...
	// UART1 Ͽ PC ų, P4 Ȥ P5  LCD  Ÿ ȸ  
	//...
	//...
	//...
	}
	//else if(pRRI->srcAddr == 0x0003) //  (̺) ּҰ  0x0003̸..
	//{
	//   ...
	//}
	//else if(pRRI->srcAddr == 0x0004) //  (̺) ּҰ  0x0004̸..
	//{
	//   ...
	//}

	return pRRI;

} // basicRfReceivePacket

//-------------------------------------------------------------------------------------------------------
//	main Լ
//-------------------------------------------------------------------------------------------------------
int main(void) 
{
//-------------------------------------------------------------------------------------------------------
// (1) I/OƮ, , ATmega128 ġ  ֺġ ʱȭ
//-------------------------------------------------------------------------------------------------------
	unsigned int srcaddr;

	PORT_INIT();
	SPI_INIT();
//	INIT_UART1(UART_BAUDRATE_115K2,UART_OPT_8_BITS_PER_CHAR); // UART1 ʱȭ(115.2 Kpbs)
//	ENABLE_UART1();

//-------------------------------------------------------------------------------------------------------
// (2) source address 
//-------------------------------------------------------------------------------------------------------
	srcaddr = 0x0001; //  巹 0x0001 ( ..)

//-------------------------------------------------------------------------------------------------------
// (3) ä  Pan ID 
//-------------------------------------------------------------------------------------------------------
	basicRfInit(&rfRxInfo, 26, 0x2176, srcaddr); // 26 ä , Pan ID = 0x2176( ..)

//-------------------------------------------------------------------------------------------------------
// (4) ۵Ÿ ũ 
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.length = 10; // 10 Ʈ ( ..)

//-------------------------------------------------------------------------------------------------------
// ACK   
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.ackRequest = TRUE;

	rfTxInfo.pPayload = pTxBuffer;
	rfRxInfo.pPayload = pRxBuffer;

//-------------------------------------------------------------------------------------------------------
// (5) ۵Ÿ ʱȭ
//-------------------------------------------------------------------------------------------------------
	for (unsigned char n = 0; n < 10; n++) 
	{
		pTxBuffer[n] = 0; // ۽  Ŭ
	}

	// Turn on RX mode
	basicRfReceiveOn();

//-------------------------------------------------------------------------------------------------------
// (6)  ƾ
//-------------------------------------------------------------------------------------------------------
	while(1) //  ݺ
	{
//-------------------------------------------------------------------------------------------------------
// (6-1) ̺꿡  Ÿ  (۵Ÿ ũ  ŭ)
//-------------------------------------------------------------------------------------------------------
		pTxBuffer[0] = 0x01; //  ..
		pTxBuffer[1] = 0x02;
		pTxBuffer[2] = 0x03;
		//...
		pTxBuffer[9] = 0x09;

//-------------------------------------------------------------------------------------------------------
// (6-2) destination address 
//-------------------------------------------------------------------------------------------------------
		rfTxInfo.destAddr = 0x0002; //  ̺ 巹 ( ..)

		// ߻!!
		basicRfSendPacket(&rfTxInfo); 

		// ̺갡 ó Ϸϰ   !! ʿ信    ..
		halWait(50000); 

	} // while(1)

} // main()
