/********************************************************************************************************
 * - PAN ID: 0x2176 for example										 								*
 * - Short address: 0x0000 ~ 0xFFFF changeable															*
 ********************************************************************************************************/

#include "include\include.h"

//-------------------------------------------------------------------------------------------------------
// Basic RF transmission and reception structures
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO rfRxInfo;
BASIC_RF_TX_INFO rfTxInfo;
BYTE pTxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];
BYTE pRxBuffer[BASIC_RF_MAX_PAYLOAD_SIZE];

//-------------------------------------------------------------------------------------------------------
// (7) ڰ ʿ信   ܺκ
//-------------------------------------------------------------------------------------------------------
//	
//  ܺκ ߰
//

//-------------------------------------------------------------------------------------------------------
// (8) ڰ ʿ信   Լ ⿡ ϰų  .c Ͽ Ѵ.
//-------------------------------------------------------------------------------------------------------
//
//  Լ ߰
//

//-------------------------------------------------------------------------------------------------------
// Ͱ  Ÿ  ó Լ
//-------------------------------------------------------------------------------------------------------
BASIC_RF_RX_INFO* basicRfReceivePacket(BASIC_RF_RX_INFO *pRRI) 
{
//-------------------------------------------------------------------------------------------------------
// (9) pRRI->pPayload[] : ͷκ  Ÿ ó
//-------------------------------------------------------------------------------------------------------
	unsigned char rfrxdata;

	rfrxdata = pRRI->pPayload[0];
	// rfrxdata = pRRI->pPayload[1];
	// rfrxdata = pRRI->pPayload[2];
	//...
	// rfrxdata = pRRI->pPayload[9];
	//...
	//...
	//...
	//  ɿ  P4 Ȥ P5    ȸ  
	//...
	//...
	//...

//-------------------------------------------------------------------------------------------------------
// Ϳ      () address destination address 
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.destAddr = pRRI->srcAddr;

//-------------------------------------------------------------------------------------------------------
// (10) Ϳ  Ÿ  (۵Ÿ ũ  ŭ)
//-------------------------------------------------------------------------------------------------------
	pTxBuffer[0] = 0x01; //  ..
	pTxBuffer[1] = 0x02;
	pTxBuffer[2] = 0x03;
	//...
	pTxBuffer[9] = 0x09;

	// ߻!!
	basicRfSendPacket(&rfTxInfo);

	return pRRI;

} // basicRfReceivePacket

//-------------------------------------------------------------------------------------------------------
//	main Լ
//-------------------------------------------------------------------------------------------------------
int main(void) 
{
//-------------------------------------------------------------------------------------------------------
// (1) I/OƮ, , ATmega128 ġ  ֺġ ʱȭ
//-------------------------------------------------------------------------------------------------------
	unsigned int srcaddr;

	PORT_INIT();
	SPI_INIT();
//	ADC_INIT();
//	ADC_SET_CHANNEL(0); // ADC0 
//	ADC_ENABLE();

//-------------------------------------------------------------------------------------------------------
// (2) source address 
//-------------------------------------------------------------------------------------------------------
	srcaddr = 0x0002; //̺0 巹 0x0002 ( ..)

//-------------------------------------------------------------------------------------------------------
// (3) ä  Pan ID 
//-------------------------------------------------------------------------------------------------------
	basicRfInit(&rfRxInfo, 26, 0x2176, srcaddr); // 26 ä , Pan ID = 0x2176( ..)

//-------------------------------------------------------------------------------------------------------
// (4) ۵Ÿ ũ 
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.length = 10; // 10 Ʈ ( ..)

//-------------------------------------------------------------------------------------------------------
// ACK   
//-------------------------------------------------------------------------------------------------------
	rfTxInfo.ackRequest = TRUE;

	rfTxInfo.pPayload = pTxBuffer;
	rfRxInfo.pPayload = pRxBuffer;

//-------------------------------------------------------------------------------------------------------
// (5) ۵Ÿ ʱȭ
//-------------------------------------------------------------------------------------------------------
	for (unsigned char n = 0; n < 10; n++) 
	{
		pTxBuffer[n] = 0; // ۽  Ŭ
	}

	// Turn on RX mode
	basicRfReceiveOn();

//-------------------------------------------------------------------------------------------------------
// (6)  ƾ
//-------------------------------------------------------------------------------------------------------
	while(1) // ̺ ͷκ  ŵǸ ͷƮ ߻Ͽ basicRfReceivePacket() 
	{
	} 

} // main()

