// PCDoc.h : interface of the CPCDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PCDOC_H__27D18DB2_B3F2_462C_B1C5_ACA035C7D70D__INCLUDED_)
#define AFX_PCDOC_H__27D18DB2_B3F2_462C_B1C5_ACA035C7D70D__INCLUDED_

#include "Serial.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CPCDoc : public CDocument
{
protected: // create from serialization only
	CPCDoc();
	DECLARE_DYNCREATE(CPCDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPCDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL m_Timeout;
	unsigned int m_RT_TABLE[2][4];
	int m_FnInuse;
	int m_PcBusy;
	CString m_strSpkpos;
	int m_SpkPos;
	int m_RxComplete;
	unsigned char m_RX_DATA[100];
	CString m_strComport;
	HWND m_hWnd;
	CSERIAL m_pSerial;
	virtual ~CPCDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CPCDoc)
	afx_msg void OnAppExit();
	afx_msg void OnComSelect();
	afx_msg void OnPosSelect();
	afx_msg void OnRecord();
	afx_msg void OnPlay();
	afx_msg void OnTransmit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PCDOC_H__27D18DB2_B3F2_462C_B1C5_ACA035C7D70D__INCLUDED_)
