// PCView.cpp : implementation of the CPCView class
//

#include "stdafx.h"
#include "PC.h"

#include "PCDoc.h"
#include "PCView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPCView

IMPLEMENT_DYNCREATE(CPCView, CFormView)

BEGIN_MESSAGE_MAP(CPCView, CFormView)
	//{{AFX_MSG_MAP(CPCView)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_RECEIVEDATA, OnSerialreceive)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCView construction/destruction

CPCView::CPCView()
	: CFormView(CPCView::IDD)
{
	//{{AFX_DATA_INIT(CPCView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CPCView::~CPCView()
{
}

void CPCView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCView)
	DDX_Control(pDX, IDC_PROGRESS3, m_transmit);
	DDX_Control(pDX, IDC_PROGRESS2, m_play);
	DDX_Control(pDX, IDC_PROGRESS1, m_record);
	//}}AFX_DATA_MAP
}

BOOL CPCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CPCView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CPCView diagnostics

#ifdef _DEBUG
void CPCView::AssertValid() const
{
	CFormView::AssertValid();
}

void CPCView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CPCDoc* CPCView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPCDoc)));
	return (CPCDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPCView message handlers

BOOL CPCView::OnSerialreceive(UINT WParam, LONG LParam)
{
	int length, tmp;
	unsigned char tmpc;

	CPCDoc *pDoc = GetDocument();

	length = (int)WParam;

	tmpc = 0;

	while ((tmpc == 0) && (length>0)) // ʿ 0x00 Էµ  
	{
		pDoc->m_pSerial.bufread.Rxchar(&tmpc);
		length--;
	}

	if (length>=0) pDoc->m_RX_DATA[0] = tmpc;

	for(tmp=1; tmp<=length; tmp++)
	{
		pDoc->m_pSerial.bufread.Rxchar(&tmpc); // ø Źۿ 1Ʈ д´.
		pDoc->m_RX_DATA[tmp] = tmpc;
	}

	pDoc->m_RxComplete = 1;

	return TRUE;
}


void CPCView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CPCDoc *pDoc = GetDocument();

	pDoc->m_Timeout = TRUE;

	CFormView::OnTimer(nIDEvent);
}
