// PCView.h : interface of the CPCView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_PCVIEW_H__BA8384A7_7FE1_4B80_8908_A69895ECC61E__INCLUDED_)
#define AFX_PCVIEW_H__BA8384A7_7FE1_4B80_8908_A69895ECC61E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CPCView : public CFormView
{
protected: // create from serialization only
	CPCView();
	DECLARE_DYNCREATE(CPCView)

public:
	//{{AFX_DATA(CPCView)
	enum { IDD = IDD_PC_FORM };
	CProgressCtrl	m_transmit;
	CProgressCtrl	m_play;
	CProgressCtrl	m_record;
	//}}AFX_DATA

// Attributes
public:
	CPCDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPCView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPCView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CPCView)
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	afx_msg BOOL OnSerialreceive(UINT WParam , LONG LParam);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in PCView.cpp
inline CPCDoc* CPCView::GetDocument()
   { return (CPCDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PCVIEW_H__BA8384A7_7FE1_4B80_8908_A69895ECC61E__INCLUDED_)
